#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=CoreTempAidThrottler_100.ico
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=Throttle CPU on high temperature
#AutoIt3Wrapper_Res_Fileversion=0.2018.6.23
#AutoIt3Wrapper_Res_ProductVersion=0.0
#AutoIt3Wrapper_Res_LegalCopyright=Freeware 2018 by argumentum
#AutoIt3Wrapper_Res_Language=0000
#AutoIt3Wrapper_Res_Field=ProductName|%scriptfile%.exe
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_100.ico, 201
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_90.ico, 202
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_err1.ico, 203
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_80.ico, 204
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_70.ico, 206
#AutoIt3Wrapper_Res_Icon_Add=CoreTempAidThrottler_paused.ico, 205
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

;~ #include <Debug.au3>

Opt("TrayAutoPause", 0) ; https://favicon.io/ | font: Lalezar | Size: 120
Opt("TrayMenuMode", 3) ; The default tray menu items will not be shown and items are not checked when selected. These are options 1 and 2 for TrayMenuMode.
Opt("TrayOnEventMode", 1) ; Enable TrayOnEventMode.

Global $AppIni = @AppDataCommonDir & '\Ly\CoreTempAidThrottler.ini'
Global $exe = StringTrimRight(@ScriptFullPath, 3) & 'exe' ;
Global $verExe = FileGetVersion($exe)
Global $g_iPaused = 0, $g_hPaused = 0, $g_iOnStart_Paused = 0, $g_iWasPaused = 0
Global $g_GuiTitle = "  " & StringTrimRight(@ScriptName, 4)
Global $g_iDoneTimeout = 0, $hWnd, $hControl

For $n = 1 To $CmdLine[0]
	If StringInStr($CmdLine[$n], "/t") = 1 And StringInStr($CmdLine[$n], ":") Then
		Exit Cmd_throttle($CmdLine[$n])
	EndIf
	If StringInStr($CmdLine[$n], "/p") = 1 Then $g_iOnStart_Paused = 1
	If $CmdLine[$n] = "/StressTestCpu" Then
		Exit StressTestCpu()
	EndIf
	If $CmdLine[$n] = "/Settings" Then
		If WinExists($g_GuiTitle) Then
			WinActivate($g_GuiTitle)
		Else
			GuiSettings()
		EndIf
		Exit 0
	EndIf
Next

If WinExists("powercfg_ProcThrottle_Automator") Then
	ShellExecute(@ScriptFullPath, '/Settings')
	Exit 2
EndIf

Func Cmd_throttle($sCmd)
	Local $a = StringSplit($sCmd, ":")
	Local $iPercent = Int($a[2])
	If $iPercent < 5 Then Return 2
	If $iPercent > 100 Then Return 3
	powercfg_ProcThrottle($iPercent)
	$g_iWasPaused = 0
	Return 0
EndFunc   ;==>Cmd_throttle

Func GuiSettings_TrayIconMeaning($iLeft = 8, $iTop = 8)
	Local $k = $iLeft + 30, $j = 2, $i = $iTop + 20, $aCtrls[20][4]
	$aCtrls[0][1] = GUICtrlCreateGroup("Tray icon meaning", $iTop, $iLeft, 110, 145)
	$aCtrls[1][0] = GUICtrlCreateIcon($exe, 201, $iLeft + 8, $i, 16, 16)
	$aCtrls[2][1] = GUICtrlCreateLabel("100% CPU", $k, $i + $j, 55, 17)
	$i += 20
	$aCtrls[2][0] = GUICtrlCreateIcon($exe, 202, $iLeft + 8, $i, 16, 16)
	$aCtrls[2][1] = GUICtrlCreateLabel("90% CPU", $k, $i + $j, 55, 17)

	$i += 20
	$aCtrls[3][0] = GUICtrlCreateIcon($exe, 204, $iLeft + 8, $i, 16, 16)
	$aCtrls[3][1] = GUICtrlCreateLabel("auto% CPU", $k, $i + $j, 65, 17)
	GUICtrlSetTip(-1, "When anti creep up kicked in")

	$i += 20
	$aCtrls[3][0] = GUICtrlCreateIcon($exe, 206, $iLeft + 8, $i, 16, 16)
	$aCtrls[3][1] = GUICtrlCreateLabel("timeout CPU", $k, $i + $j, 65, 17)
	GUICtrlSetTip(-1, "TCP took too long to respond" & @CR & "(possible under very heavy load)")

	$i += 20
	$aCtrls[4][0] = GUICtrlCreateIcon($exe, 203, $iLeft + 8, $i, 16, 16)
	$aCtrls[4][1] = GUICtrlCreateLabel("OFF", $k, $i + $j, 55, 17)
	GUICtrlSetTip($aCtrls[4][1], "could not connect to ""Core Temp Remote Server""")
	$i += 20
	$aCtrls[5][0] = GUICtrlCreateIcon($exe, 205, $iLeft + 8, $i, 16, 16)
	$aCtrls[5][1] = GUICtrlCreateLabel("Paused", $k, $i + $j, 55, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Return $aCtrls
EndFunc   ;==>GuiSettings_TrayIconMeaning

Func GuiSettings()
	If Not FileExists(@AppDataCommonDir & '\Ly') Then DirCreate(@AppDataCommonDir & '\Ly')
	Local $n, $s, $msg, $m, $i, $v, $a
	Local $Form1 = GUICreate($g_GuiTitle & ' [v.' & $verExe & ']', 400, 280, @DesktopWidth / 2, @DesktopHeight / 4, -1, BitOR($WS_EX_LAYERED, $WS_EX_COMPOSITED))
	Local $stestAv = GUICtrlCreateLabel("", 128, 104, 258, 40, -1, -1)
	Local $aGuiSettings_TrayIconMeaning = GuiSettings_TrayIconMeaning()

	Local $Group1 = GUICtrlCreateGroup("CoreTemp Port:", 128, 8, 97, 41)
	Local $Input1 = GUICtrlCreateInput("5200", 136, 24, 81, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER))
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$v = 16
	Local $Label4 = GUICtrlCreateLabel("Trigger when", 24, 149 + $v, 85, 17, $SS_RIGHT)
	Local $Combo1 = GUICtrlCreateCombo("", 112, 147 + $v, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	Local $LabelIsAbove = GUICtrlCreateLabel("is above", 24, 172 + $v, 85, 17, $SS_RIGHT)
	Local $Combo2 = GUICtrlCreateCombo("", 112, 170 + $v, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	Local $Label6 = GUICtrlCreateLabel("set throttle to", 24, 195 + $v, 85, 17, $SS_RIGHT)
	Local $Combo3 = GUICtrlCreateCombo("", 112, 193 + $v, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))

	Local $Set = GUICtrlCreateButton("Set", 280, 147 + $v, 107, 25)
	Local $Close = GUICtrlCreateButton("Close", 280, 189 + $v, 107, 25)

	$v += 23
	Local $LabelTOut = GUICtrlCreateLabel("on timeout set to", 24, 195 + $v, 85, 17, $SS_RIGHT)
	Local $ComboTOut = GUICtrlCreateCombo("", 112, 193 + $v, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	Local $CheckboxTOut = GUICtrlCreateCheckbox("", 112 + 145, 193 + $v, 17, 17, BitOR($GUI_SS_DEFAULT_CHECKBOX, $BS_RIGHTBUTTON, $BS_RIGHT))


	Local $idATCUGroup = GUICtrlCreateGroup("Anti teperature creep up", 128, 52, 257, 48)
	Local $idAntiCreepUp = GUICtrlCreateCheckbox("", 362, 61, 17, 17, BitOR($GUI_SS_DEFAULT_CHECKBOX, $BS_RIGHTBUTTON, $BS_RIGHT))
	GUICtrlSetTip(-1, "will use even lower CPU throttle" & @CR & "decrementing 5% every 5 sec." & @CR & "until max. temp. is under 90 C.")
	Local $idATCUCombo = GUICtrlCreateCombo("", 192, 72, 62, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	GUICtrlSetTip(-1, "temp. should not" & @CR & "be lower than trigger")
	Local $idATCULabel = GUICtrlCreateLabel("kick in at ", 136, 75, 52, 17, $SS_RIGHT)
	Local $idATCULabel2 = GUICtrlCreateLabel(" after ", 258, 75, 28, 17, $SS_CENTER)
	Local $idATCUtime = GUICtrlCreateCombo("", 292, 72, 65, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	GUICtrlSetTip(-1, "temp. should not" & @CR & "be lower than trigger")
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	Local $StressSel = GUICtrlCreateButton("Stress test CPU", 231, 18, 157, 25)
	GUICtrlSetTip(-1, "max. out selected count")


	If Int(IniRead($AppIni, "Settings", "OnTimeoutAct", 1)) Then
		GUICtrlSetState($CheckboxTOut, 1)
	Else
		GUICtrlSetState($LabelTOut, $GUI_DISABLE)
		GUICtrlSetState($ComboTOut, $GUI_DISABLE)
	EndIf

	If Int(IniRead($AppIni, "Settings", "AntiCreepUpCpuThrottle", 1)) Then GUICtrlSetState($idAntiCreepUp, 1)
	If Int(IniRead($AppIni, "Settings", "PROCESSORS", 1)) > 1 Then GUICtrlSetData($LabelIsAbove, "are above")

	Local $HyperLink_AutoIt = hlink("Visit: AutoIt forum", 'to read about this utility', 140, 260, 100, 17)
	Local $HyperLink_CoreTemp = hlink("Visit: CoreTemp", 'to read about "Core Temp"', 19, 260, 100, 17)
	Local $HyperLink_coderbag = hlink("Visit: coderbag", 'to read about "CPU core parking manager v3"', 280, 260, 100, 17)

	GUISetState(@SW_SHOW)

	GUICtrlSetTip($idAntiCreepUp, "will use even lower CPU throttle" & @CR & "decrementing 5% every X sec." & @CR & "until max. temp. is lower than set C.")
	GUICtrlSetTip($idATCUCombo, "temp. should be set" & @CR & "to 10 C. higher than trigger")

	GUICtrlSetData($aGuiSettings_TrayIconMeaning[2][1], Int(IniRead($AppIni, "Settings", "PROCTHROTTLE", 99)) & '% CPU')
	Local $iAntiCreepUp = ChkBoxIO($idAntiCreepUp), $dNUMBER_OF_Cores, $sNUMBER_OF_Cores = '1 core'
	Local $iNUMBER_OF_Cores = f_NumberOfCores()
	Local $iNUMBER_OF_PROCESSORS = @extended
	If @error Then GUICtrlSetTip($Combo1, "if you set more cores" & @CR & "than there are" & @CR & "this will never kick")
	If Int(IniRead($AppIni, "Settings", "PROCESSORS", 1)) > 1 Then
		$dNUMBER_OF_Cores = Int(IniRead($AppIni, "Settings", "PROCESSORS", 1)) & " cores"
	Else
		$dNUMBER_OF_Cores = "1 core"
	EndIf

	For $n = 2 To $iNUMBER_OF_Cores
		$sNUMBER_OF_Cores &= '|' & $n & ' cores'
	Next
	GUICtrlSetData($Combo1, $sNUMBER_OF_Cores, $dNUMBER_OF_Cores)

	Local $sTemperature = "98 C."
	For $n = 96 To 60 Step -2
		$sTemperature &= '|' & $n & ' C.'
	Next
	GUICtrlSetData($Combo2, $sTemperature, Int(IniRead($AppIni, "Settings", "TEMPERATURE", 78)) & ' C.')
	GUICtrlSetData($idATCUCombo, $sTemperature, Int(IniRead($AppIni, "Settings", "ATCUtemp", 88)) & ' C.')

	$sTemperature = "0 sec."
	For $n = 1 To 10
		$sTemperature &= '|' & $n & ' sec.'
	Next
	GUICtrlSetData($idATCUtime, $sTemperature, Int(IniRead($AppIni, "Settings", "ATCUtime", 0)) & ' sec.')

	AntiCreepUpGuiState($idAntiCreepUp, $idATCUCombo, $idATCUtime, $idATCULabel, $idATCULabel2)

	Local $sPROCTHROTTLE = "99%"
	For $n = 95 To 50 Step -5
		$sPROCTHROTTLE &= '|' & $n & '%'
	Next
	GUICtrlSetData($Combo3, $sPROCTHROTTLE, Int(IniRead($AppIni, "Settings", "PROCTHROTTLE", 99)) & '%')
	GUICtrlSetData($ComboTOut, "100|" & $sPROCTHROTTLE, Int(IniRead($AppIni, "Settings", "OnTimeout", 75)) & '%')
	GUICtrlSetData($Input1, Int(IniRead($AppIni, "Settings", "PORT", 5200)))

	Local $aStressTestCtrls[$iNUMBER_OF_PROCESSORS + 2][2]
	$aStressTestCtrls[0][0] = $iNUMBER_OF_PROCESSORS + 1
	$aStressTestCtrls[0][1] = GUICtrlCreateDummy()
	$aStressTestCtrls[1][1] = GUICtrlCreateContextMenu($aStressTestCtrls[0][1])
	$aStressTestCtrls[1][0] = GUICtrlCreateMenuItem("Span 1 process", $aStressTestCtrls[1][1])
	For $n = 2 To $iNUMBER_OF_PROCESSORS
		$aStressTestCtrls[$n][0] = GUICtrlCreateMenuItem("Span " & $n & " processes", $aStressTestCtrls[1][1])
	Next
	$aStressTestCtrls[$n][0] = GUICtrlCreateMenuItem("Span " & ($iNUMBER_OF_PROCESSORS * 2) & " processes", $aStressTestCtrls[1][1])

	Local $StressTesting = 0, $sec = @SEC, $StressTestingCount, $StressTestingThr, $CoreTemp

	While 1
		If $sec <> @SEC Then
			$sec = @SEC
			$s = ""
			$a = StringSplit(ControlGetText("powercfg_ProcThrottle_Automator", "", "Edit1"), @CRLF, 1)
			For $n = 1 To $a[0]
				If StringInStr($a[$n], "CoreTemp=") Then
					$CoreTemp = "CoreTemp: " & StringReplace(StringTrimLeft($a[$n], StringLen("CoreTemp=")), ":", " : ")
				EndIf
				If StringInStr($a[$n], "Throttle=") Then
					$StressTestingThr = "Throttle: " & StringTrimLeft($a[$n], StringLen("Throttle=")) & "%"
				EndIf
				If StringInStr($a[$n], "Paused=1") Then
					$CoreTemp = ""
					$StressTestingThr = @CR & "Throttler is Paused."
				EndIf
			Next
			If $StressTesting Then
				$a = WinList("StressTestCpu by CoreTempAidThrottler")
				$s = 0
				For $n = 1 To UBound($a) - 1
					$s += Int(StringTrimLeft($a[$n][0], StringLen("StressTestCpu by CoreTempAidThrottler - "))) & @CR
				Next
				$s = "Process efficiency: ( in kilo cycles )( " & $StressTestingCount & " CPU wasters )" & @CR & "Total: " & $s & "  |  Average: " & Int(($s / ($n - 1))) & "  |  "
			EndIf
			$s &= $StressTestingThr & @CR & $CoreTemp
			GUICtrlSetData($stestAv, $s)
		EndIf
		$msg = GUIGetMsg()
		Switch $msg
			Case 0
				ContinueLoop
			Case $GUI_EVENT_CLOSE, $Close
				GUIDelete($Form1)
				While WinExists('StressTestCpu by CoreTempAidThrottler')
					WinClose('StressTestCpu by CoreTempAidThrottler')
					Sleep(1)
				WEnd
				ExitLoop

			Case $Combo1
				If Int(GUICtrlRead($Combo1)) > 1 Then
					GUICtrlSetData($LabelIsAbove, "are above")
				Else
					GUICtrlSetData($LabelIsAbove, "is above")
				EndIf
;~ 				GUICtrlSetState($Label1, $GUI_FOCUS)

			Case $Combo2
;~ 				GUICtrlSetState($Label1, $GUI_FOCUS)

			Case $Combo3
;~ 				GUICtrlSetState($Label1, $GUI_FOCUS)

			Case $HyperLink_AutoIt
				ShellExecute('https://www.autoitscript.com/forum/topic/194420-slow-down-cpu-cooler-cpu-fan-idle/')

			Case $HyperLink_coderbag
				ShellExecute('http://coderbag.com/Programming-C/CPU-core-parking-manager-v3')

			Case $HyperLink_CoreTemp
				ShellExecute('https://www.alcpu.com/CoreTemp/')

			Case $idAntiCreepUp
				AntiCreepUpGuiState($idAntiCreepUp, $idATCUCombo, $idATCUtime, $idATCULabel, $idATCULabel2)

			Case $CheckboxTOut
				If GUICtrlRead($CheckboxTOut) = 1 Then
					GUICtrlSetState($ComboTOut, $GUI_ENABLE)
					GUICtrlSetState($LabelTOut, $GUI_ENABLE)
				Else
					GUICtrlSetState($ComboTOut, $GUI_DISABLE)
					GUICtrlSetState($LabelTOut, $GUI_DISABLE)
				EndIf

			Case $Set
				GUICtrlSetState($Set, $GUI_DISABLE)
				IniWrite($AppIni, "Settings", "PROCESSORS", Int(GUICtrlRead($Combo1)))
				IniWrite($AppIni, "Settings", "TEMPERATURE", Int(GUICtrlRead($Combo2)))
				IniWrite($AppIni, "Settings", "ATCUtemp", Int(GUICtrlRead($idATCUCombo)))
				IniWrite($AppIni, "Settings", "ATCUtime", Int(GUICtrlRead($idATCUtime)))
				IniWrite($AppIni, "Settings", "PROCTHROTTLE", Int(GUICtrlRead($Combo3)))
				IniWrite($AppIni, "Settings", "PORT", Int(GUICtrlRead($Input1)))
				IniWrite($AppIni, "Settings", "OnTimeout", Int(GUICtrlRead($ComboTOut)))
				IniWrite($AppIni, "Settings", "AntiCreepUpCpuThrottle", ChkBoxIO($idAntiCreepUp))
				IniWrite($AppIni, "Settings", "OnTimeoutAct", ChkBoxIO($CheckboxTOut))

				GUICtrlSetData($aGuiSettings_TrayIconMeaning[2][1], Int(GUICtrlRead($Combo3)) & '% CPU')
				WinClose("powercfg_ProcThrottle_Automator")
				WinWaitClose("powercfg_ProcThrottle_Automator", "", 5)
				ShellExecute(@ScriptFullPath)
				GUICtrlSetState($Set, $GUI_ENABLE)
;~ 				GUICtrlSetState($Label1, $GUI_FOCUS)

			Case $StressSel
				GUICtrlSetState($StressSel, $GUI_DISABLE)
				If GUICtrlRead($msg) = "STOP TEST" Then
					$StressTesting = 0
					GUICtrlSetData($StressSel, "Stopping " & $i & " processes")
					While WinExists('StressTestCpu by CoreTempAidThrottler')
						WinClose('StressTestCpu by CoreTempAidThrottler')
						GUIGetMsg()
					WEnd
					GUICtrlSetData($stestAv, "")
					GUICtrlSetData($StressSel, "Stress test CPU")
				Else
					ShowMenu($Form1, $msg, $aStressTestCtrls[1][1])
				EndIf
				GUICtrlSetState($StressSel, $GUI_ENABLE)

			Case Else
				If $msg < 0 Then ContinueLoop
				For $n = 1 To $aStressTestCtrls[0][0]
					If $aStressTestCtrls[$n][0] = $msg Then
						GUICtrlSetState($StressSel, $GUI_DISABLE)
						GUICtrlSetData($StressSel, "STOP TEST")
						$i = Int(StringTrimLeft(GUICtrlRead($aStressTestCtrls[$n][0], 1), StringLen("Span ")))
						$StressTestingCount = $i
						For $m = 1 To $i
							ShellExecute(@ScriptFullPath, '/StressTestCpu')
							GUIGetMsg()
						Next
						GUICtrlSetState($StressSel, $GUI_ENABLE)
						$StressTesting = 1
						ExitLoop
					EndIf
				Next

		EndSwitch
	WEnd
EndFunc   ;==>GuiSettings

Func ChkBoxIO($id)
	If GUICtrlRead($id) = 1 Then Return 1
	Return 0
EndFunc   ;==>ChkBoxIO

Func AntiCreepUpGuiState(ByRef $idAntiCreepUp, ByRef $idATCUCombo, ByRef $idATCUtime, ByRef $idATCULabel, ByRef $idATCULabel2)
	If ChkBoxIO($idAntiCreepUp) Then
		GUICtrlSetState($idATCUCombo, $GUI_ENABLE)
		GUICtrlSetState($idATCUtime, $GUI_ENABLE)
		GUICtrlSetState($idATCULabel, $GUI_ENABLE)
		GUICtrlSetState($idATCULabel2, $GUI_ENABLE)
	Else
		GUICtrlSetState($idATCUCombo, $GUI_DISABLE)
		GUICtrlSetState($idATCUtime, $GUI_DISABLE)
		GUICtrlSetState($idATCULabel, $GUI_DISABLE)
		GUICtrlSetState($idATCULabel2, $GUI_DISABLE)
	EndIf
EndFunc   ;==>AntiCreepUpGuiState

Func f_NumberOfCores()
	Local $n, $a, $p = Int(EnvGet("NUMBER_OF_PROCESSORS")), $s = RunExe(@ComSpec & ' /C wmic cpu get NumberOfCores /Format:List')
	$a = StringSplit($s, @CRLF)
	For $n = 1 To UBound($a) - 1
		If StringInStr($a[$n], "NumberOfCores=") Then
			Return SetError(0, $p, Int(StringReplace($a[$n], "NumberOfCores=", "")))
		EndIf
	Next
	Return SetError(1, $p, $p)
EndFunc   ;==>f_NumberOfCores

Func hlink($sText, $sTip, $left, $top, $width = -1, $height = -1)
	Local $Label = GUICtrlCreateLabel($sText, $left, $top, $width, $height)
	GUICtrlSetCursor($Label, 0)
	GUICtrlSetColor($Label, 0x0000ff)
	GUICtrlSetFont($Label, 9, 400, 4)
	If $sTip Then GUICtrlSetTip($Label, $sTip)
	Return $Label
EndFunc   ;==>hlink

AutoItWinSetTitle("powercfg_ProcThrottle_Automator") ; the TITLE for the tray icon process
If Not TCPStartup() Then Exit 3 ; Start the TCP service.
; Register OnAutoItExit to be called when the script is closed.
OnAutoItExitRegister("OnAutoItExit")
Func OnAutoItExit()
	TCPShutdown() ; Close the TCP service.
;~ 	powercfg_ProcThrottle(90)
EndFunc   ;==>OnAutoItExit

;~ powercfg_ProcThrottle(100)
Func powercfg_ProcThrottle($iPercent = 100)
;~ 	ConslWrite('+ powercfg_ProcThrottle( ' & $iPercent & ' )' & @CRLF)
	Local $s
	$s &= RunExe(@ComSpec & ' /c powercfg -setacvalueindex scheme_current sub_processor PROCTHROTTLEMIN ' & $iPercent) & @CRLF
	$s &= RunExe(@ComSpec & ' /c powercfg -setacvalueindex scheme_current sub_processor PROCTHROTTLEMAX ' & $iPercent) & @CRLF
	$s &= RunExe(@ComSpec & ' /c powercfg -setactive scheme_current') & @CRLF
	ConslWrite('+ powercfg_ProcThrottle( ' & $iPercent & ' )' & @TAB & @HOUR & ':' & @MIN & ':' & @SEC & '.' & @MSEC & @TAB & StringReplace($s, @CRLF & @CRLF & @CRLF, '') & @CRLF)
	$g_iWasPaused = 0
EndFunc   ;==>powercfg_ProcThrottle

Func TCPConnect_CoreTemp(ByRef $iSocket)
	Do
		$iSocket = TCPConnect("127.0.0.1", Int(IniRead($AppIni, "Settings", "PORT", 5200)))
		; If an error occurred display the error code and return False.
		If @error Then
			; The server is probably offline/port is not opened on the server.
			$iError = @error
			TraySetIcon($exe, 203)
			TraySetToolTip('ProcThrottle: OFF' & @CR & 'TCP to CoreTemp FAILED' & @CR & ' ')
			Sleep(5000)
			ContinueLoop
		EndIf
		ExitLoop
	Until 1 = 2
EndFunc   ;==>TCPConnect_CoreTemp

Func f_ExitScript()
	powercfg_ProcThrottle(100)
	Exit
EndFunc   ;==>f_ExitScript
Func f_Cancel()
EndFunc   ;==>f_Cancel
Func f_Settings()
	ShellExecute(@ScriptFullPath, '/Settings')
EndFunc   ;==>f_Settings
Func ConslWrite($s = "")
	If @Compiled Then Return
	ConsoleWrite($s)
EndFunc   ;==>ConslWrite
Func f_Pause()
	If $g_iPaused Then
		$g_iPaused = 0
		$g_iWasPaused = 1
		TraySetIcon($exe, 201)
		TraySetToolTip('ProcThrottle: 100%' & @CR & ' ')
		TrayItemSetState($g_hPaused, 4) ; $TRAY_UNCHECKED = 4 ; Menuitem will be unchecked
		$g_iDoneTimeout = 0
	Else
		$g_iPaused = 1
		TraySetIcon($exe, 205)
		TraySetToolTip('ProcThrottle: Paused' & @CR & ' ')
		TrayItemSetState($g_hPaused, 1) ; $TRAY_CHECKED = 1 ; Menuitem will be checked
		ControlSetText($hWnd, "", $hControl, "Paused=" & $g_iPaused & @CRLF & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
	EndIf
	powercfg_ProcThrottle(100)
EndFunc   ;==>f_Pause
Func f_BrowseFolder()
	ShellExecute(@ScriptDir)
EndFunc   ;==>f_BrowseFolder

main()
Func main()

	Local $iNUMBER_OF_Cores = Int(IniRead($AppIni, "Settings", "PROCESSORS", 1))
	Local $iPROCTHROTTLE = Int(IniRead($AppIni, "Settings", "PROCTHROTTLE", 99))
	Local $iTEMPERATURE = Int(IniRead($AppIni, "Settings", "TEMPERATURE", 78))
	Local $iATCUtemp = Int(IniRead($AppIni, "Settings", "ATCUtemp", 88))
	Local $iATCUtime = Int(IniRead($AppIni, "Settings", "ATCUtime", 0))
	Local $iOnTimeout = Int(IniRead($AppIni, "Settings", "OnTimeout", 75))
	Local $iOnTimeoutAct = Int(IniRead($AppIni, "Settings", "OnTimeoutAct", 1))
	If $iATCUtime Then $iATCUtime = $iATCUtime * 1000
	Local $tAntiCreepUpCpuThrottle = TimerInit(), $dAntiCreepUpCpuThrottle = $iPROCTHROTTLE, $iAntiCreepUpCpuThrottle = Int(IniRead($AppIni, "Settings", "AntiCreepUpCpuThrottle", 1))
	TrayCreateItem("Exit")
	TrayItemSetOnEvent(-1, "f_ExitScript")

	TrayCreateItem("") ; Create a separator line.
	TrayCreateItem("Settings")
	TrayItemSetOnEvent(-1, "f_Settings")
	TraySetOnEvent(-13, "f_Settings") ; $TRAY_EVENT_PRIMARYDOUBLE -13
	TrayCreateItem("")
	$g_hPaused = TrayCreateItem("Pause")
	TrayItemSetOnEvent(-1, "f_Pause")
	TrayCreateItem("")
	TrayCreateItem("Browse folder")
	TrayItemSetOnEvent(-1, "f_BrowseFolder")
	TrayCreateItem("")
	If @Compiled Then
		TrayCreateItem("Cancel menu")
	Else
		TrayCreateItem("Cancel (script)")
	EndIf
	TrayItemSetOnEvent(-1, "f_Cancel")
	TraySetClick(16) ; Releasing secondary mouse button
	$hWnd = WinGetHandle("powercfg_ProcThrottle_Automator")
	$hControl = ControlGetHandle("powercfg_ProcThrottle_Automator", "", "Edit1")
	Local $tt, $t, $iSocket, $reduced = 0, $c, $m, $n, $a, $b, $i = 0, $s, $iError = 0, $ucFahrenheit = 0, $sStatusCpu = "", $sStatusThrottle = "", $ttt
	$sStatusThrottle = 'ReducedStep=-1' & @CRLF
	$sStatusThrottle &= 'Throttle=OFF' & @CRLF
	ControlSetText($hWnd, "", $hControl, $sStatusThrottle & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
	TCPConnect_CoreTemp($iSocket)

	TraySetToolTip('ProcThrottle: 100%' & @CR & ' ')
	$sStatusThrottle = 'ReducedStep=0' & @CRLF
	$sStatusThrottle &= 'Throttle=100' & @CRLF
	ControlSetText($hWnd, "", $hControl, $sStatusThrottle & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)

	powercfg_ProcThrottle(100)
	TraySetIcon($exe, 201)
	TraySetToolTip('ProcThrottle: 100%' & @CR & ' ')
	$t = TimerInit()
	$tt = TimerInit()

	If $g_iOnStart_Paused Then f_Pause()
;~ 	WinSetState("powercfg_ProcThrottle_Automator", "", @SW_SHOW)


	While Sleep(1)
		$s = TCPRecv($iSocket, 8096)
;~ 		ConsoleWrite('> -----' & @CRLF)
		If @error Then ; ..where is MY data ???? Or TimerDiff($t) > 20000
			ConslWrite('-' & Round(TimerDiff($t)) & ' ms. / @error = ' & @error & @CRLF)

;~ 			powercfg_ProcThrottle($iPROCTHROTTLE)
;~ 			$reduced = 1
;~ 			TraySetIcon($exe, 202)
;~ 			TraySetToolTip('ProcThrottle: ' & $iPROCTHROTTLE & '%' & @CR & ' ')
;~ 			$sStatusThrottle = 'ReducedStep=-1' & @CRLF
;~ 			$sStatusThrottle &= 'Throttle=' & $iPROCTHROTTLE & @CRLF
;~ 			ControlSetText($hWnd, "", $hControl, $sStatusThrottle & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)

			TCPCloseSocket($iSocket)
			TCPConnect_CoreTemp($iSocket)

;~ 			powercfg_ProcThrottle(100)
;~ 			$reduced = 0
;~ 			TraySetIcon($exe, 201)
;~ 			TraySetToolTip('ProcThrottle: 100%' & @CR & ' ')
;~ 			$sStatusThrottle = 'ReducedStep=0' & @CRLF
;~ 			$sStatusThrottle &= 'Throttle=100' & @CRLF
;~ 			ControlSetText($hWnd, "", $hControl, $sStatusThrottle & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)

		EndIf

		; emergency state
		If $iOnTimeoutAct And Not $g_iPaused And Not $g_iWasPaused Then
			If TimerDiff($t) > 2000 And $g_iDoneTimeout = 0 Then
				$dAntiCreepUpCpuThrottle = $iOnTimeout
				powercfg_ProcThrottle($dAntiCreepUpCpuThrottle)
				$reduced = 1
				$g_iDoneTimeout = 1
				TraySetIcon($exe, 206)
				TraySetToolTip('ProcThrottle: ' & $dAntiCreepUpCpuThrottle & '%' & @CR & 'by timeout')
				$sStatusThrottle = 'ReducedStep=-2' & @CRLF
				$sStatusThrottle &= 'Throttle=' & $dAntiCreepUpCpuThrottle & @CRLF
				$sStatusCpu = "CoreTemp=???" & @CRLF
				ControlSetText($hWnd, "", $hControl, $sStatusCpu & $sStatusThrottle & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
			EndIf
		EndIf

		If $s = "" Then
			ContinueLoop
		Else
			$ttt = $t
			$t = TimerInit()
		EndIf

		If $iOnTimeoutAct And (TimerDiff($t) > 2000 Or TimerDiff($ttt) > 2000) Then ContinueLoop
		$a = StringSplit($s, '"', 1)
		If $g_iPaused Then ContinueLoop
		$sStatusCpu = ""
		$g_iDoneTimeout = 0

;~ 		_DebugArrayDisplay($a)
		For $n = 1 To $a[0] - 2
			If $a[$n] = "fCPUSpeed" Then
				ConslWrite('fCPUSpeed = ' & Int(StringTrimLeft($a[$n + 1], 1)) & @TAB) ; if the user would like the info, get it from CoreTemp  ;)
				$sStatusCpu &= 'fCPUSpeed=' & Int(StringTrimLeft($a[$n + 1], 1)) & @CRLF
			EndIf

			If $a[$n] = "fMultiplier" Then
				ConslWrite('fMultiplier = ' & Int(StringTrimLeft($a[$n + 1], 1)) & @CRLF)
				$sStatusCpu &= 'fMultiplier=' & Int(StringTrimLeft($a[$n + 1], 1)) & @CRLF
			EndIf

			If $a[$n] = "ucFahrenheit" Then $ucFahrenheit = Int(StringTrimLeft($a[$n + 1], 1))

			If $a[$n] = "fTemp" Then
				ConslWrite($a[$n + 1] & @TAB & Round(TimerDiff($tt)) & ' ms.' & @TAB)
				$tt = TimerInit()
				$b = StringSplit(StringTrimRight(StringTrimLeft($a[$n + 1], 2), 2), ':[,]')
				$c = 0
				$d = 0
				$sStatusCpu &= "CoreTemp="
				For $m = 1 To $b[0]
					If $ucFahrenheit Then $b[$m] = Int(($b[$m] - 32) * (5 / 9))
					If $m > 1 Then $sStatusCpu &= ":"
					$sStatusCpu &= $b[$m]
					If $b[$m] > $iTEMPERATURE Then $c += 1
					If $b[$m] >= $iATCUtemp Then $d = 1
				Next
				$sStatusCpu &= @CRLF
				If $c >= $iNUMBER_OF_Cores Then ; it's getting HOT, so we slow down the CPU
					If $reduced = 0 Then
						powercfg_ProcThrottle($iPROCTHROTTLE)
						$g_iWasPaused = 0
						TraySetIcon($exe, 202)
						TraySetToolTip('ProcThrottle: ' & $iPROCTHROTTLE & '%' & @CR & ' ')
						$reduced = 1
						$tAntiCreepUpCpuThrottle = TimerInit()
						$sStatusThrottle = 'ReducedStep=1' & @CRLF
						$sStatusThrottle &= 'Throttle=' & $iPROCTHROTTLE & @CRLF

					Else
						If $iAntiCreepUpCpuThrottle Then
							If TimerDiff($tAntiCreepUpCpuThrottle) > $iATCUtime Then
								If $d Then
									$tAntiCreepUpCpuThrottle = TimerInit()
									$dAntiCreepUpCpuThrottle -= 5
									If $dAntiCreepUpCpuThrottle < 30 Then
										$dAntiCreepUpCpuThrottle = 30
									Else
										powercfg_ProcThrottle($dAntiCreepUpCpuThrottle)
										$g_iWasPaused = 0
										TraySetIcon($exe, 204)
										TraySetToolTip('ProcThrottle: ' & $dAntiCreepUpCpuThrottle & '%' & @CR & ' ')
										$sStatusThrottle = 'ReducedStep=2' & @CRLF
										$sStatusThrottle &= 'Throttle=' & $dAntiCreepUpCpuThrottle & @CRLF

									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				Else
					If $reduced = 1 Then
						powercfg_ProcThrottle(100)
						$g_iWasPaused = 0
						TraySetIcon($exe, 201)
						TraySetToolTip('ProcThrottle: 100%' & @CR & ' ')
						$tAntiCreepUpCpuThrottle = TimerInit()
						$dAntiCreepUpCpuThrottle = $iPROCTHROTTLE
						$sStatusThrottle = 'ReducedStep=0' & @CRLF
						$sStatusThrottle &= 'Throttle=100' & @CRLF
					EndIf
					$reduced = 0
				EndIf
;~ 				ExitLoop
			EndIf
		Next
		ControlSetText($hWnd, "", $hControl, "Paused=" & $g_iPaused & @CRLF & $sStatusThrottle & $sStatusCpu & "Time=" & @YEAR & '.' & @MON & '.' & @MDAY & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
	WEnd
	TCPCloseSocket($iSocket)
EndFunc   ;==>main

Func StressTestCpu() ; endless, useless loop to max. out CPU
	AutoItWinSetTitle('StressTestCpu by CoreTempAidThrottler - 0')
	Local $sec = @SEC, $iLoop = 0
	Do
		If $iLoop Then $iLoop += 1
		If $sec = @SEC Then ContinueLoop
		$sec = @SEC
		If $iLoop Then AutoItWinSetTitle('StressTestCpu by CoreTempAidThrottler - ' & Int($iLoop / 1000))
		$iLoop = 1
	Until 1 = 2
EndFunc   ;==>StressTestCpu

Func RunExe($s)
	Local $Pid = Run($s, @TempDir, @SW_HIDE, 6) ; 6 = $STDERR_CHILD + $STDOUT_CHILD
	Local $Handle = _ProcessExitCode($Pid)
	Local $sIn = ShowStdOutErr($Pid)
	Local $ExitCode = _ProcessExitCode($Pid, $Handle)
	_ProcessCloseHandle($Handle)
	Return SetError($ExitCode, 0, $sIn)
EndFunc   ;==>RunExe

Func ShowStdOutErr($l_Handle, $ShowConsole = 0)
	Local $Line = "x", $Line2 = "x", $tot_out, $err1 = 0, $err2 = 0, $cnt1 = 0, $cnt2 = 0
	Do
		Sleep(10)
		$Line = StdoutRead($l_Handle)
		$err1 = @error
		$tot_out &= $Line
		If $ShowConsole Then ConslWrite($Line)
		$Line2 = StderrRead($l_Handle)
		$err2 = @error
		$tot_out &= $Line2
		If $ShowConsole Then ConslWrite($Line2)
		; end the loop also when AutoIt3 has ended but a sub process was shelled with Run() that is still active
		; only do this every 50 cycles to avoid cpu hunger
		If $cnt1 = 50 Then
			$cnt1 = 0
			; loop another 50 times just to ensure the buffers emptied.
			If Not ProcessExists($l_Handle) Then
				If $cnt2 > 2 Then ExitLoop
				$cnt2 += 1
			EndIf
		EndIf
		$cnt1 += 1
	Until ($err1 And $err2)
	Return $tot_out
EndFunc   ;==>ShowStdOutErr
Func _ProcessExitCode($i_Pid, $h_Process = 0)
	; 0 = Return Process Handle of PID else use Handle to Return Exitcode of a PID
	Local $v_Placeholder
	If Not IsArray($h_Process) Then
		; Return the process handle of a PID
		$h_Process = DllCall('kernel32.dll', 'ptr', 'OpenProcess', 'int', 0x400, 'int', 0, 'int', $i_Pid)
		If Not @error Then Return $h_Process
	Else
		; Return Process Exitcode of PID
		$h_Process = DllCall('kernel32.dll', 'ptr', 'GetExitCodeProcess', 'ptr', $h_Process[0], 'int*', $v_Placeholder)
		If Not @error Then Return $h_Process[2]
	EndIf
	Return 0
EndFunc   ;==>_ProcessExitCode
Func _ProcessCloseHandle($h_Process)
	; Close the process handle of a PID
	DllCall('kernel32.dll', 'ptr', 'CloseHandle', 'ptr', $h_Process)
	If Not @error Then Return 1
	Return 0
EndFunc   ;==>_ProcessCloseHandle

; Show a menu in a given GUI window which belongs to a given GUI ctrl
Func ShowMenu($hWnd, $idCtrl, $idContext)
	Local $aPos, $x, $y
	Local $hMenu = GUICtrlGetHandle($idContext)

	$aPos = ControlGetPos($hWnd, "", $idCtrl)

	$x = $aPos[0]
	$y = $aPos[1] + $aPos[3]

	ClientToScreen($hWnd, $x, $y)
	TrackPopupMenu($hWnd, $hMenu, $x, $y)
EndFunc   ;==>ShowMenu
; Convert the client (GUI) coordinates to screen (desktop) coordinates
Func ClientToScreen($hWnd, ByRef $x, ByRef $y)
	Local $tPoint = DllStructCreate("int;int")

	DllStructSetData($tPoint, 1, $x)
	DllStructSetData($tPoint, 2, $y)

	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $hWnd, "struct*", $tPoint)

	$x = DllStructGetData($tPoint, 1)
	$y = DllStructGetData($tPoint, 2)
	; release Struct not really needed as it is a local
	$tPoint = 0
EndFunc   ;==>ClientToScreen
; Show at the given coordinates (x, y) the popup menu (hMenu) which belongs to a given GUI window (hWnd)
Func TrackPopupMenu($hWnd, $hMenu, $x, $y)
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $hMenu, "int", 0, "int", $x, "int", $y, "hwnd", $hWnd, "ptr", 0)
EndFunc   ;==>TrackPopupMenu
